function disp(X,varargin)
  %assert(fc_linalg3D.is3Darray(X));
  assert( ismember(ndims(X),[2,3]) )
  p = inputParser;
  p.addParamValue('name',inputname(1),@ischar);
  p.addParamValue('selected', [] );
  p.addParamValue('n', 2 );
  p.parse(varargin{:});
  name=p.Results.name;
  selected=p.Results.selected;
  n=p.Results.n;
  N=size(X,1);
  if ndims(X)==2, nc=1;else nc=size(X,3);end
  fprintf('  %s is a %d-by-%d-by-%d 3D-array\n',name,N,size(X,2),nc)
  if isempty(selected)
    if N>2*n
      print_part(X,name,1:n,nc)
      fprintf('  ...\n\n')
      print_part(X,name,N-n+1:N,nc)
    else  
      print_part(X,name,1:N,nc)
    end
    return
  end
  print_part(X,name,selected,nc)
end

function print_part(X,name,selected,nc)
  if isempty(name),name='3D-array';end
  if nc==1,getX=@(X,k) squeeze(X(k,:,:)).'; else getX=@(X,k) squeeze(X(k,:,:));end
  for k=selected
    fprintf('  %s(%d,:,:)=\n',name,k);
    disp(getX(X,k))
  end
end
